<!doctype html>
<html class="default no-js">
<head>
	<meta charset="utf-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<title>Bitcoin one way channel</title>
	<meta name="description" content="">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<link rel="stylesheet" href="assets/css/main.css">
</head>
<body>
<header>
	<div class="tsd-page-toolbar">
		<div class="container">
			<div class="table-wrap">
				<div class="table-cell" id="tsd-search" data-index="assets/js/search.js" data-base=".">
					<div class="field">
						<label for="tsd-search-field" class="tsd-widget search no-caption">Search</label>
						<input id="tsd-search-field" type="text" />
					</div>
					<ul class="results">
						<li class="state loading">Preparing search index...</li>
						<li class="state failure">The search index is not available</li>
					</ul>
					<a href="index.html" class="title">Bitcoin one way channel</a>
				</div>
				<div class="table-cell" id="tsd-widgets">
					<div id="tsd-filter">
						<a href="#" class="tsd-widget options no-caption" data-toggle="options">Options</a>
						<div class="tsd-filter-group">
							<div class="tsd-select" id="tsd-filter-visibility">
								<span class="tsd-select-label">All</span>
								<ul class="tsd-select-list">
									<li data-value="public">Public</li>
									<li data-value="protected">Public/Protected</li>
									<li data-value="private" class="selected">All</li>
								</ul>
							</div>
							<input type="checkbox" id="tsd-filter-inherited" checked />
							<label class="tsd-widget" for="tsd-filter-inherited">Inherited</label>
							<input type="checkbox" id="tsd-filter-externals" checked />
							<label class="tsd-widget" for="tsd-filter-externals">Externals</label>
							<input type="checkbox" id="tsd-filter-only-exported" />
							<label class="tsd-widget" for="tsd-filter-only-exported">Only exported</label>
						</div>
					</div>
					<a href="#" class="tsd-widget menu no-caption" data-toggle="menu">Menu</a>
				</div>
			</div>
		</div>
	</div>
	<div class="tsd-page-title">
		<div class="container">
			<ul class="tsd-breadcrumb">
				<li>
					<a href="globals.html">Globals</a>
				</li>
			</ul>
			<h1> Bitcoin one way channel</h1>
		</div>
	</div>
</header>
<div class="container container-main">
	<div class="row">
		<div class="col-8 col-content">
			<section class="tsd-panel-group tsd-index-group">
				<h2>Index</h2>
				<section class="tsd-panel tsd-index-panel">
					<div class="tsd-index-content">
						<section class="tsd-index-section ">
							<h3>Modules</h3>
							<ul class="tsd-index-list">
								<li class="tsd-kind-module"><a href="modules/derivation.html" class="tsd-kind-icon">derivation</a></li>
							</ul>
						</section>
						<section class="tsd-index-section ">
							<h3>Classes</h3>
							<ul class="tsd-index-list">
								<li class="tsd-kind-class"><a href="classes/btc.html" class="tsd-kind-icon">Btc</a></li>
								<li class="tsd-kind-class"><a href="classes/client.html" class="tsd-kind-icon">Client</a></li>
								<li class="tsd-kind-class"><a href="classes/clientkernel.html" class="tsd-kind-icon">Client<wbr>Kernel</a></li>
								<li class="tsd-kind-class"><a href="classes/kernel.html" class="tsd-kind-icon">Kernel</a></li>
								<li class="tsd-kind-class"><a href="classes/multisig.html" class="tsd-kind-icon">Multisig</a></li>
								<li class="tsd-kind-class tsd-is-not-exported"><a href="classes/multisigclient.html" class="tsd-kind-icon">Multisig<wbr>Client</a></li>
								<li class="tsd-kind-class tsd-is-not-exported"><a href="classes/multisigprovider.html" class="tsd-kind-icon">Multisig<wbr>Provider</a></li>
								<li class="tsd-kind-class"><a href="classes/protocol.html" class="tsd-kind-icon">Protocol</a></li>
								<li class="tsd-kind-class"><a href="classes/revpubkey.html" class="tsd-kind-icon">Rev<wbr>Pubkey</a></li>
								<li class="tsd-kind-class tsd-is-not-exported"><a href="classes/revpubkeyclient.html" class="tsd-kind-icon">Rev<wbr>Pubkey<wbr>Client</a></li>
								<li class="tsd-kind-class tsd-is-not-exported"><a href="classes/revpubkeyprovider.html" class="tsd-kind-icon">Rev<wbr>Pubkey<wbr>Provider</a></li>
								<li class="tsd-kind-class"><a href="classes/server.html" class="tsd-kind-icon">Server</a></li>
								<li class="tsd-kind-class"><a href="classes/serverkernel.html" class="tsd-kind-icon">Server<wbr>Kernel</a></li>
								<li class="tsd-kind-class"><a href="classes/testkernel.html" class="tsd-kind-icon">Test<wbr>Kernel</a></li>
							</ul>
						</section>
						<section class="tsd-index-section ">
							<h3>Interfaces</h3>
							<ul class="tsd-index-list">
								<li class="tsd-kind-interface"><a href="interfaces/channeladdress.html" class="tsd-kind-icon">Channel<wbr>Address</a></li>
								<li class="tsd-kind-interface"><a href="interfaces/channelstatetransition.html" class="tsd-kind-icon">Channel<wbr>State<wbr>Transition</a></li>
								<li class="tsd-kind-interface"><a href="interfaces/clientproviderpubkeys.html" class="tsd-kind-icon">Client<wbr>Provider<wbr>Pubkeys</a></li>
								<li class="tsd-kind-interface"><a href="interfaces/requestapi.html" class="tsd-kind-icon">Request<wbr>Api</a></li>
								<li class="tsd-kind-interface"><a href="interfaces/revpubkey.html" class="tsd-kind-icon">Rev<wbr>Pub<wbr>Key</a></li>
								<li class="tsd-kind-interface"><a href="interfaces/tx.html" class="tsd-kind-icon">Tx</a></li>
								<li class="tsd-kind-interface"><a href="interfaces/utxo.html" class="tsd-kind-icon">Utxo</a></li>
								<li class="tsd-kind-interface"><a href="interfaces/utxoandwif.html" class="tsd-kind-icon">Utxo<wbr>And<wbr>Wif</a></li>
							</ul>
						</section>
						<section class="tsd-index-section ">
							<h3>Type aliases</h3>
							<ul class="tsd-index-list">
								<li class="tsd-kind-type-alias"><a href="globals.html#apiname" class="tsd-kind-icon">Api<wbr>Name</a></li>
								<li class="tsd-kind-type-alias"><a href="globals.html#channeltx" class="tsd-kind-icon">Channel<wbr>Tx</a></li>
								<li class="tsd-kind-type-alias"><a href="globals.html#networkname" class="tsd-kind-icon">Network<wbr>Name</a></li>
								<li class="tsd-kind-type-alias"><a href="globals.html#transition" class="tsd-kind-icon">Transition</a></li>
							</ul>
						</section>
						<section class="tsd-index-section ">
							<h3>Variables</h3>
							<ul class="tsd-index-list">
								<li class="tsd-kind-variable tsd-is-not-exported"><a href="globals.html#biginteger" class="tsd-kind-icon">Big<wbr>Integer</a></li>
								<li class="tsd-kind-variable tsd-is-not-exported"><a href="globals.html#op_checksequenceverify" class="tsd-kind-icon">OP_<wbr>CHECKSEQUENCEVERIFY</a></li>
								<li class="tsd-kind-variable"><a href="globals.html#apiname" class="tsd-kind-icon">api<wbr>Name</a></li>
								<li class="tsd-kind-variable tsd-is-not-exported"><a href="globals.html#host" class="tsd-kind-icon">host</a></li>
								<li class="tsd-kind-variable"><a href="globals.html#networkname" class="tsd-kind-icon">network<wbr>Name</a></li>
							</ul>
						</section>
						<section class="tsd-index-section ">
							<h3>Functions</h3>
							<ul class="tsd-index-list">
								<li class="tsd-kind-function"><a href="globals.html#btcapi" class="tsd-kind-icon">BTCApi</a></li>
								<li class="tsd-kind-function"><a href="globals.html#btcapiinsight" class="tsd-kind-icon">BTCApi<wbr>Insight</a></li>
								<li class="tsd-kind-function"><a href="globals.html#btcapirpc" class="tsd-kind-icon">BTCApiRPC</a></li>
								<li class="tsd-kind-function"><a href="globals.html#csvrevpubkeyoutput" class="tsd-kind-icon">csv<wbr>Rev<wbr>Pub<wbr>Key<wbr>Output</a></li>
								<li class="tsd-kind-function"><a href="globals.html#derivechanneladdress" class="tsd-kind-icon">derive<wbr>Channel<wbr>Address</a></li>
								<li class="tsd-kind-function"><a href="globals.html#deriverevpubkey" class="tsd-kind-icon">derive<wbr>Rev<wbr>Pubkey</a></li>
								<li class="tsd-kind-function"><a href="globals.html#deriverevsecret" class="tsd-kind-icon">derive<wbr>Rev<wbr>Secret</a></li>
								<li class="tsd-kind-function"><a href="globals.html#deriveusernode" class="tsd-kind-icon">derive<wbr>User<wbr>Node</a></li>
								<li class="tsd-kind-function"><a href="globals.html#fundingtransaction" class="tsd-kind-icon">funding<wbr>Transaction</a></li>
								<li class="tsd-kind-function"><a href="globals.html#generateseed" class="tsd-kind-icon">generate<wbr>Seed</a></li>
								<li class="tsd-kind-function"><a href="globals.html#getfeeperbyte" class="tsd-kind-icon">get<wbr>Fee<wbr>Per<wbr>Byte</a></li>
								<li class="tsd-kind-function"><a href="globals.html#getoutputs" class="tsd-kind-icon">get<wbr>Outputs</a></li>
								<li class="tsd-kind-function"><a href="globals.html#getpubkeys" class="tsd-kind-icon">get<wbr>Pubkeys</a></li>
								<li class="tsd-kind-function"><a href="globals.html#refundtransaction" class="tsd-kind-icon">refund<wbr>Transaction</a></li>
								<li class="tsd-kind-function"><a href="globals.html#registerchannel" class="tsd-kind-icon">register<wbr>Channel</a></li>
								<li class="tsd-kind-function"><a href="globals.html#revhashfromsecret" class="tsd-kind-icon">rev<wbr>Hash<wbr>From<wbr>Secret</a></li>
								<li class="tsd-kind-function"><a href="globals.html#revokerefundtransaction" class="tsd-kind-icon">revoke<wbr>Refund<wbr>Transaction</a></li>
								<li class="tsd-kind-function"><a href="globals.html#settlementtransaction" class="tsd-kind-icon">settlement<wbr>Transaction</a></li>
								<li class="tsd-kind-function"><a href="globals.html#spendrefundtransaction" class="tsd-kind-icon">spend<wbr>Refund<wbr>Transaction</a></li>
								<li class="tsd-kind-function"><a href="globals.html#statetransition" class="tsd-kind-icon">state<wbr>Transition</a></li>
								<li class="tsd-kind-function"><a href="globals.html#validbalancesorthrow" class="tsd-kind-icon">valid<wbr>Balances<wbr>OrThrow</a></li>
								<li class="tsd-kind-function"><a href="globals.html#verifysignature" class="tsd-kind-icon">verify<wbr>Signature</a></li>
								<li class="tsd-kind-function"><a href="globals.html#withdrawtransaction" class="tsd-kind-icon">withdraw<wbr>Transaction</a></li>
							</ul>
						</section>
						<section class="tsd-index-section tsd-is-not-exported">
							<h3>Object literals</h3>
							<ul class="tsd-index-list">
								<li class="tsd-kind-object-literal tsd-is-not-exported"><a href="globals.html#common" class="tsd-kind-icon">common</a></li>
							</ul>
						</section>
					</div>
				</section>
			</section>
			<section class="tsd-panel-group tsd-member-group ">
				<h2>Type aliases</h2>
				<section class="tsd-panel tsd-member tsd-kind-type-alias">
					<a name="apiname" class="tsd-anchor"></a>
					<h3>Api<wbr>Name</h3>
					<div class="tsd-signature tsd-kind-icon">Api<wbr>Name<span class="tsd-signature-symbol">:</span> <span class="tsd-signature-type">"btcrpc"</span><span class="tsd-signature-symbol"> | </span><span class="tsd-signature-type">"insight"</span></div>
					<aside class="tsd-sources">
						<ul>
							<li>Defined in lib/common/types.ts:67</li>
						</ul>
					</aside>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-type-alias">
					<a name="channeltx" class="tsd-anchor"></a>
					<h3>Channel<wbr>Tx</h3>
					<div class="tsd-signature tsd-kind-icon">Channel<wbr>Tx<span class="tsd-signature-symbol">:</span> <a href="interfaces/tx.html" class="tsd-signature-type">Tx</a><span class="tsd-signature-symbol"> &amp; </span><span class="tsd-signature-type">object</span></div>
					<aside class="tsd-sources">
						<ul>
							<li>Defined in lib/common/types.ts:180</li>
						</ul>
					</aside>
					<div class="tsd-comment tsd-typography">
						<div class="lead">
							<p>Export the channel tx type that extend the tx type with a channel state
							transition object.</p>
						</div>
					</div>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-type-alias">
					<a name="networkname" class="tsd-anchor"></a>
					<h3>Network<wbr>Name</h3>
					<div class="tsd-signature tsd-kind-icon">Network<wbr>Name<span class="tsd-signature-symbol">:</span> <span class="tsd-signature-type">"bitcoin"</span><span class="tsd-signature-symbol"> | </span><span class="tsd-signature-type">"regtest"</span><span class="tsd-signature-symbol"> | </span><span class="tsd-signature-type">"testnet"</span></div>
					<aside class="tsd-sources">
						<ul>
							<li>Defined in lib/common/types.ts:78</li>
						</ul>
					</aside>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-type-alias">
					<a name="transition" class="tsd-anchor"></a>
					<h3>Transition</h3>
					<div class="tsd-signature tsd-kind-icon">Transition<span class="tsd-signature-symbol">:</span> <span class="tsd-signature-symbol">[</span><span class="tsd-signature-type">0</span><span class="tsd-signature-symbol">, </span><span class="tsd-signature-type">0</span><span class="tsd-signature-symbol">]</span><span class="tsd-signature-symbol"> | </span><span class="tsd-signature-symbol">[</span><span class="tsd-signature-type">0</span><span class="tsd-signature-symbol">, </span><span class="tsd-signature-type">2</span><span class="tsd-signature-symbol">]</span><span class="tsd-signature-symbol"> | </span><span class="tsd-signature-symbol">[</span><span class="tsd-signature-type">1</span><span class="tsd-signature-symbol">, </span><span class="tsd-signature-type">0</span><span class="tsd-signature-symbol">]</span><span class="tsd-signature-symbol"> | </span><span class="tsd-signature-symbol">[</span><span class="tsd-signature-type">null</span><span class="tsd-signature-symbol">, </span><span class="tsd-signature-type">null</span><span class="tsd-signature-symbol">]</span></div>
					<aside class="tsd-sources">
						<ul>
							<li>Defined in lib/common/types.ts:157</li>
						</ul>
					</aside>
					<div class="tsd-comment tsd-typography">
						<div class="lead">
							<p>Represent all the possible transaction for the state i and n.</p>
						</div>
					</div>
				</section>
			</section>
			<section class="tsd-panel-group tsd-member-group ">
				<h2>Variables</h2>
				<section class="tsd-panel tsd-member tsd-kind-variable tsd-is-not-exported">
					<a name="biginteger" class="tsd-anchor"></a>
					<h3>Big<wbr>Integer</h3>
					<div class="tsd-signature tsd-kind-icon">Big<wbr>Integer<span class="tsd-signature-symbol">:</span> <span class="tsd-signature-type">BigNumber</span><span class="tsd-signature-symbol"> =&nbsp;BigNumber.another({DECIMAL_PLACES: 0,// HALF_FLOOR 8 Towards nearest neighbour. If equidistant, towards// -Infinity.ROUNDING_MODE: 8,RANGE: [-15, 15]})</span></div>
					<aside class="tsd-sources">
						<ul>
							<li>Defined in lib/common/btc.ts:3</li>
						</ul>
					</aside>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-variable tsd-is-not-exported">
					<a name="op_checksequenceverify" class="tsd-anchor"></a>
					<h3>OP_<wbr>CHECKSEQUENCEVERIFY</h3>
					<div class="tsd-signature tsd-kind-icon">OP_<wbr>CHECKSEQUENCEVERIFY<span class="tsd-signature-symbol">:</span> <span class="tsd-signature-type">number</span><span class="tsd-signature-symbol"> =&nbsp;opcodes.OP_NOP3</span></div>
					<aside class="tsd-sources">
						<ul>
							<li>Defined in lib/common/transaction/output/revpubkey.ts:4</li>
						</ul>
					</aside>
					<div class="tsd-comment tsd-typography">
						<div class="lead">
							<p>Declare the check sequence verify op_code</p>
						</div>
					</div>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-variable">
					<a name="apiname" class="tsd-anchor"></a>
					<h3>api<wbr>Name</h3>
					<div class="tsd-signature tsd-kind-icon">api<wbr>Name<span class="tsd-signature-symbol">:</span> <span class="tsd-signature-symbol">[</span><span class="tsd-signature-type">"btcrpc"</span><span class="tsd-signature-symbol">, </span><span class="tsd-signature-type">"insight"</span><span class="tsd-signature-symbol">]</span><span class="tsd-signature-symbol"> =&nbsp;[&#x27;btcrpc&#x27;, &#x27;insight&#x27;]</span></div>
					<aside class="tsd-sources">
						<ul>
							<li>Defined in lib/common/types.ts:66</li>
						</ul>
					</aside>
					<div class="tsd-comment tsd-typography">
						<div class="lead">
							<p>Represent the apis supported by the library for network communication.</p>
						</div>
						<p>has to be explicitly specified as tuple (otherwise inferred as array of
							strings) for type inference to work, the reason of repeating.
						ref stackoverflow: <a href="https://goo.gl/Bh8wn6">https://goo.gl/Bh8wn6</a></p>
					</div>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-variable tsd-is-not-exported">
					<a name="host" class="tsd-anchor"></a>
					<h3>host</h3>
					<div class="tsd-signature tsd-kind-icon">host<span class="tsd-signature-symbol">:</span> <span class="tsd-signature-type">any</span><span class="tsd-signature-symbol"> =&nbsp;process.env.RPC_HOST || &#x27;127.0.0.1&#x27;</span></div>
					<aside class="tsd-sources">
						<ul>
							<li>Defined in lib/common/api/btcapirpc.ts:4</li>
						</ul>
					</aside>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-variable">
					<a name="networkname" class="tsd-anchor"></a>
					<h3>network<wbr>Name</h3>
					<div class="tsd-signature tsd-kind-icon">network<wbr>Name<span class="tsd-signature-symbol">:</span> <span class="tsd-signature-symbol">[</span><span class="tsd-signature-type">"bitcoin"</span><span class="tsd-signature-symbol">, </span><span class="tsd-signature-type">"regtest"</span><span class="tsd-signature-symbol">, </span><span class="tsd-signature-type">"testnet"</span><span class="tsd-signature-symbol">]</span><span class="tsd-signature-symbol"> =&nbsp;[&#x27;bitcoin&#x27;, &#x27;regtest&#x27;, &#x27;testnet&#x27;]</span></div>
					<aside class="tsd-sources">
						<ul>
							<li>Defined in lib/common/types.ts:76</li>
						</ul>
					</aside>
					<div class="tsd-comment tsd-typography">
						<div class="lead">
							<p>Represent the three different network in bitcoin.</p>
						</div>
						<p>has to be explicitly specified as tuple (otherwise inferred as array of
							strings) for type inference to work, the reason of repeating.
						ref stackoverflow: <a href="https://goo.gl/Bh8wn6">https://goo.gl/Bh8wn6</a></p>
					</div>
				</section>
			</section>
			<section class="tsd-panel-group tsd-member-group ">
				<h2>Functions</h2>
				<section class="tsd-panel tsd-member tsd-kind-function">
					<a name="btcapi" class="tsd-anchor"></a>
					<h3>BTCApi</h3>
					<ul class="tsd-signatures tsd-kind-function">
						<li class="tsd-signature tsd-kind-icon">BTCApi<span class="tsd-signature-symbol">(</span>net<span class="tsd-signature-symbol">?: </span><a href="globals.html#networkname" class="tsd-signature-type">NetworkName</a>, apiName<span class="tsd-signature-symbol">?: </span><a href="globals.html#apiname" class="tsd-signature-type">ApiName</a><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><a href="interfaces/requestapi.html" class="tsd-signature-type">RequestApi</a></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/common/api/btcapi.ts:5</li>
								</ul>
							</aside>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5><span class="tsd-flag ts-flagDefault value">Default value</span> net: <a href="globals.html#networkname" class="tsd-signature-type">NetworkName</a><span class="tsd-signature-symbol"> =&nbsp;&quot;testnet&quot;</span></h5>
								</li>
								<li>
									<h5><span class="tsd-flag ts-flagDefault value">Default value</span> apiName: <a href="globals.html#apiname" class="tsd-signature-type">ApiName</a><span class="tsd-signature-symbol"> =&nbsp;&quot;btcrpc&quot;</span></h5>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <a href="interfaces/requestapi.html" class="tsd-signature-type">RequestApi</a></h4>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-function">
					<a name="btcapiinsight" class="tsd-anchor"></a>
					<h3>BTCApi<wbr>Insight</h3>
					<ul class="tsd-signatures tsd-kind-function">
						<li class="tsd-signature tsd-kind-icon">BTCApi<wbr>Insight<span class="tsd-signature-symbol">(</span>net<span class="tsd-signature-symbol">?: </span><a href="globals.html#networkname" class="tsd-signature-type">NetworkName</a><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><a href="interfaces/requestapi.html" class="tsd-signature-type">RequestApi</a></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/common/api/btcapiinsight.ts:4</li>
								</ul>
							</aside>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5><span class="tsd-flag ts-flagDefault value">Default value</span> net: <a href="globals.html#networkname" class="tsd-signature-type">NetworkName</a><span class="tsd-signature-symbol"> =&nbsp;&quot;testnet&quot;</span></h5>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <a href="interfaces/requestapi.html" class="tsd-signature-type">RequestApi</a></h4>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-function">
					<a name="btcapirpc" class="tsd-anchor"></a>
					<h3>BTCApiRPC</h3>
					<ul class="tsd-signatures tsd-kind-function">
						<li class="tsd-signature tsd-kind-icon">BTCApiRPC<span class="tsd-signature-symbol">(</span>net<span class="tsd-signature-symbol">?: </span><a href="globals.html#networkname" class="tsd-signature-type">NetworkName</a><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><a href="interfaces/requestapi.html" class="tsd-signature-type">RequestApi</a></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/common/api/btcapirpc.ts:12</li>
								</ul>
							</aside>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5><span class="tsd-flag ts-flagDefault value">Default value</span> net: <a href="globals.html#networkname" class="tsd-signature-type">NetworkName</a><span class="tsd-signature-symbol"> =&nbsp;&quot;testnet&quot;</span></h5>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <a href="interfaces/requestapi.html" class="tsd-signature-type">RequestApi</a></h4>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-function">
					<a name="csvrevpubkeyoutput" class="tsd-anchor"></a>
					<h3>csv<wbr>Rev<wbr>Pub<wbr>Key<wbr>Output</h3>
					<ul class="tsd-signatures tsd-kind-function">
						<li class="tsd-signature tsd-kind-icon">csv<wbr>Rev<wbr>Pub<wbr>Key<wbr>Output<span class="tsd-signature-symbol">(</span>senderPubkey<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">Buffer</span>, receiverPubkey<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">Buffer</span>, blocksInFuture<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">number</span>, revHash<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">Buffer</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">Buffer</span></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/common/transaction/output/revpubkey.ts:28</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p>Generate a compiled revPubKey contract script used in the channel for locking
									funds to a contract that protect both sides.</p>
								</div>
								<pre><code>IF
  <span class="hljs-tag">&lt;<span class="hljs-name">senderPubkey</span>&gt;</span> CHECKSIG
  <span class="hljs-tag">&lt;<span class="hljs-name">blocksInFuture</span>&gt;</span> CHECKSEQUENCEVERIFY DROP
ELSE
  <span class="hljs-tag">&lt;<span class="hljs-name">receiverPubkey</span>&gt;</span> CHECKSIGVERIFY
  HASH160 <span class="hljs-tag">&lt;<span class="hljs-name">revokationHash</span>&gt;</span> EQUAL
ENDIF
</code></pre>
							</div>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>senderPubkey: <span class="tsd-signature-type">Buffer</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the sender public key used to lock the funds
											with the timelock</p>
										</div>
									</div>
								</li>
								<li>
									<h5>receiverPubkey: <span class="tsd-signature-type">Buffer</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the receiver public key used to lock the
											funds with the revokation secret</p>
										</div>
									</div>
								</li>
								<li>
									<h5>blocksInFuture: <span class="tsd-signature-type">number</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the timelock number</p>
										</div>
									</div>
								</li>
								<li>
									<h5>revHash: <span class="tsd-signature-type">Buffer</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the revokation hash used with the receiverPubkey</p>
										</div>
									</div>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <span class="tsd-signature-type">Buffer</span></h4>
							<p>the compiled revPubKey script</p>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-function">
					<a name="derivechanneladdress" class="tsd-anchor"></a>
					<h3>derive<wbr>Channel<wbr>Address</h3>
					<ul class="tsd-signatures tsd-kind-function">
						<li class="tsd-signature tsd-kind-icon">derive<wbr>Channel<wbr>Address<span class="tsd-signature-symbol">(</span>pubkeys<span class="tsd-signature-symbol">: </span><a href="interfaces/clientproviderpubkeys.html" class="tsd-signature-type">ClientProviderPubkeys</a>, network<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">Network</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><a href="interfaces/channeladdress.html" class="tsd-signature-type">ChannelAddress</a></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/common/address/derivechannel.ts:13</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p>Create the multisig address and the corresponding redeemScript for the
										given state i. The MultisigPubkeys object contains both HDNode derived to
									obtain the nodes to create the multi signature script for the given network.</p>
								</div>
							</div>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>pubkeys: <a href="interfaces/clientproviderpubkeys.html" class="tsd-signature-type">ClientProviderPubkeys</a></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>all the keys used in the multisig address</p>
										</div>
									</div>
								</li>
								<li>
									<h5>network: <span class="tsd-signature-type">Network</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the network used to derive the multisig</p>
										</div>
									</div>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <a href="interfaces/channeladdress.html" class="tsd-signature-type">ChannelAddress</a></h4>
							<p>the ChannelAddress object</p>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-function">
					<a name="deriverevpubkey" class="tsd-anchor"></a>
					<h3>derive<wbr>Rev<wbr>Pubkey</h3>
					<ul class="tsd-signatures tsd-kind-function">
						<li class="tsd-signature tsd-kind-icon">derive<wbr>Rev<wbr>Pubkey<span class="tsd-signature-symbol">(</span>pubkeys<span class="tsd-signature-symbol">: </span><a href="interfaces/clientproviderpubkeys.html" class="tsd-signature-type">ClientProviderPubkeys</a>, revHash<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">Buffer</span>, blocksInFuture<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">number</span>, network<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">Network</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><a href="interfaces/revpubkey.html" class="tsd-signature-type">RevPubKey</a></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/common/address/deriverevpubkey.ts:17</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p>Create the custom P2SH called revPubKey contract in the paper. This P2SH
										contains two branch: (i) a revokation hash and a signature, (ii) a timelock
										and a signature. The client has to wait for the timelock before spending the
									money and the provider can take the money if he knows the revokation hash.</p>
								</div>
							</div>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>pubkeys: <a href="interfaces/clientproviderpubkeys.html" class="tsd-signature-type">ClientProviderPubkeys</a></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>all the keys used in the multisig address</p>
										</div>
									</div>
								</li>
								<li>
									<h5>revHash: <span class="tsd-signature-type">Buffer</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the revokation hash used in the contract</p>
										</div>
									</div>
								</li>
								<li>
									<h5>blocksInFuture: <span class="tsd-signature-type">number</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the number of block for the timelock</p>
										</div>
									</div>
								</li>
								<li>
									<h5>network: <span class="tsd-signature-type">Network</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the network used to create the contract address</p>
										</div>
									</div>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <a href="interfaces/revpubkey.html" class="tsd-signature-type">RevPubKey</a></h4>
							<p>the RevPubKey contract</p>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-function">
					<a name="deriverevsecret" class="tsd-anchor"></a>
					<h3>derive<wbr>Rev<wbr>Secret</h3>
					<ul class="tsd-signatures tsd-kind-function">
						<li class="tsd-signature tsd-kind-icon">derive<wbr>Rev<wbr>Secret<span class="tsd-signature-symbol">(</span>clientAccount<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">HDNode</span>, i<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">number</span>, n<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">number</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/common/secrets/revsecret.ts:12</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p>Derive the secret with the client node, used for revocation purpose.</p>
								</div>
							</div>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>clientAccount: <span class="tsd-signature-type">HDNode</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the root node used to derive the secret</p>
										</div>
									</div>
								</li>
								<li>
									<h5>i: <span class="tsd-signature-type">number</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the index i used to derive the second part of the secret</p>
										</div>
									</div>
								</li>
								<li>
									<h5>n: <span class="tsd-signature-type">number</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the index n used to derive the first part of the secret</p>
										</div>
									</div>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <span class="tsd-signature-type">string</span></h4>
							<p>the secret for the given channel state</p>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-function">
					<a name="deriveusernode" class="tsd-anchor"></a>
					<h3>derive<wbr>User<wbr>Node</h3>
					<ul class="tsd-signatures tsd-kind-function">
						<li class="tsd-signature tsd-kind-icon">derive<wbr>User<wbr>Node<span class="tsd-signature-symbol">(</span>node<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">HDNode</span>, i<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">number</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">any</span></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/common/address/getpubkeys.ts:4</li>
								</ul>
							</aside>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>node: <span class="tsd-signature-type">HDNode</span></h5>
								</li>
								<li>
									<h5>i: <span class="tsd-signature-type">number</span></h5>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <span class="tsd-signature-type">any</span></h4>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-function">
					<a name="fundingtransaction" class="tsd-anchor"></a>
					<h3>funding<wbr>Transaction</h3>
					<ul class="tsd-signatures tsd-kind-function">
						<li class="tsd-signature tsd-kind-icon">funding<wbr>Transaction<span class="tsd-signature-symbol">(</span>utxosAndWifs<span class="tsd-signature-symbol">: </span><a href="interfaces/utxoandwif.html" class="tsd-signature-type">UtxoAndWif</a><span class="tsd-signature-symbol">[]</span>, channelAddress<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">Buffer</span>, feePerByte<span class="tsd-signature-symbol">: </span><a href="classes/btc.html" class="tsd-signature-type">Btc</a>, network<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">Network</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><a href="globals.html#channeltx" class="tsd-signature-type">ChannelTx</a></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/common/transaction/fundingtx.ts:18</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p>Create a funding transaction that consume all the given utxos
										and send it to the channel address. Each input must be signed
									by the funding address node.</p>
								</div>
							</div>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>utxosAndWifs: <a href="interfaces/utxoandwif.html" class="tsd-signature-type">UtxoAndWif</a><span class="tsd-signature-symbol">[]</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>object containing and array with
												properties utxo and the corresponding WIF that unlocks the respective utxo,
											used to fund the channel</p>
										</div>
									</div>
								</li>
								<li>
									<h5>channelAddress: <span class="tsd-signature-type">Buffer</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the output script for the channel address</p>
										</div>
									</div>
								</li>
								<li>
									<h5>feePerByte: <a href="classes/btc.html" class="tsd-signature-type">Btc</a></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>amount of satoshis per bytes of fee</p>
										</div>
									</div>
								</li>
								<li>
									<h5>network: <span class="tsd-signature-type">Network</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the network used to create the tx</p>
										</div>
									</div>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <a href="globals.html#channeltx" class="tsd-signature-type">ChannelTx</a></h4>
							<p>an object that contains the transaction</p>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-function">
					<a name="generateseed" class="tsd-anchor"></a>
					<h3>generate<wbr>Seed</h3>
					<ul class="tsd-signatures tsd-kind-function">
						<li class="tsd-signature tsd-kind-icon">generate<wbr>Seed<span class="tsd-signature-symbol">(</span>network<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">Network</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/common/key/genseed.ts:11</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p>Create a random HDNode and return his representation in base58. This method
									is used to generate random nodes in the demo.</p>
								</div>
							</div>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>network: <span class="tsd-signature-type">Network</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the network used to generate the Node</p>
										</div>
									</div>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <span class="tsd-signature-type">string</span></h4>
							<p>the base58 representation</p>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-function">
					<a name="getfeeperbyte" class="tsd-anchor"></a>
					<h3>get<wbr>Fee<wbr>Per<wbr>Byte</h3>
					<ul class="tsd-signatures tsd-kind-function">
						<li class="tsd-signature tsd-kind-icon">get<wbr>Fee<wbr>Per<wbr>Byte<span class="tsd-signature-symbol">(</span>priority<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">"fastestFee"</span><span class="tsd-signature-symbol"> | </span><span class="tsd-signature-type">"halfHourFee"</span><span class="tsd-signature-symbol"> | </span><span class="tsd-signature-type">"hourFee"</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">Promise</span><span class="tsd-signature-symbol">&lt;</span><a href="classes/btc.html" class="tsd-signature-type">Btc</a><span class="tsd-signature-symbol">&gt;</span></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/common/api/feeapi.ts:4</li>
								</ul>
							</aside>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>priority: <span class="tsd-signature-type">"fastestFee"</span><span class="tsd-signature-symbol"> | </span><span class="tsd-signature-type">"halfHourFee"</span><span class="tsd-signature-symbol"> | </span><span class="tsd-signature-type">"hourFee"</span></h5>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <span class="tsd-signature-type">Promise</span><span class="tsd-signature-symbol">&lt;</span><a href="classes/btc.html" class="tsd-signature-type">Btc</a><span class="tsd-signature-symbol">&gt;</span></h4>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-function">
					<a name="getoutputs" class="tsd-anchor"></a>
					<h3>get<wbr>Outputs</h3>
					<ul class="tsd-signatures tsd-kind-function">
						<li class="tsd-signature tsd-kind-icon">get<wbr>Outputs<span class="tsd-signature-symbol">(</span>transaction<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">Transaction</span>, network<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">Network</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><a href="interfaces/utxo.html" class="tsd-signature-type">Utxo</a><span class="tsd-signature-symbol">[]</span></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/common/transaction/helper.ts:15</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p>Return an array of UTXOs for the new created transaction. Warning: this
										list of utxos can be false if the transaction is not complete, or can
										change over time. This method is used to chain the transactions in the
									channel.</p>
								</div>
							</div>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>transaction: <span class="tsd-signature-type">Transaction</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the transaction object from the bitcoinjs
											library</p>
										</div>
									</div>
								</li>
								<li>
									<h5>network: <span class="tsd-signature-type">Network</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the network used to compute the address</p>
										</div>
									</div>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <a href="interfaces/utxo.html" class="tsd-signature-type">Utxo</a><span class="tsd-signature-symbol">[]</span></h4>
							<p>the list of all the transaction outputs on the Utxo form</p>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-function">
					<a name="getpubkeys" class="tsd-anchor"></a>
					<h3>get<wbr>Pubkeys</h3>
					<ul class="tsd-signatures tsd-kind-function">
						<li class="tsd-signature tsd-kind-icon">get<wbr>Pubkeys<span class="tsd-signature-symbol">(</span>clientAcc<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">HDNode</span>, providerAcc<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">HDNode</span>, i<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">number</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><a href="interfaces/clientproviderpubkeys.html" class="tsd-signature-type">ClientProviderPubkeys</a></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/common/address/getpubkeys.ts:7</li>
								</ul>
							</aside>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>clientAcc: <span class="tsd-signature-type">HDNode</span></h5>
								</li>
								<li>
									<h5>providerAcc: <span class="tsd-signature-type">HDNode</span></h5>
								</li>
								<li>
									<h5>i: <span class="tsd-signature-type">number</span></h5>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <a href="interfaces/clientproviderpubkeys.html" class="tsd-signature-type">ClientProviderPubkeys</a></h4>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-function">
					<a name="refundtransaction" class="tsd-anchor"></a>
					<h3>refund<wbr>Transaction</h3>
					<ul class="tsd-signatures tsd-kind-function">
						<li class="tsd-signature tsd-kind-icon">refund<wbr>Transaction<span class="tsd-signature-symbol">(</span>utxos<span class="tsd-signature-symbol">: </span><a href="interfaces/utxo.html" class="tsd-signature-type">Utxo</a><span class="tsd-signature-symbol">[]</span>, revPubKeyAddress<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">Buffer</span>, providerBalance<span class="tsd-signature-symbol">: </span><a href="classes/btc.html" class="tsd-signature-type">Btc</a>, clientBalanceBeforeFee<span class="tsd-signature-symbol">: </span><a href="classes/btc.html" class="tsd-signature-type">Btc</a>, feePerByte<span class="tsd-signature-symbol">: </span><a href="classes/btc.html" class="tsd-signature-type">Btc</a>, providerAddress<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span>, network<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">Network</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><a href="globals.html#channeltx" class="tsd-signature-type">ChannelTx</a></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/common/transaction/refundtx.ts:22</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p>Create a refunding transaction that consume the funds into the multisig
										address i and spend it to the revPubKey address i-n. The refund address can
										have one output (for the first refund transaction) or two output (one to the
										revPubKey address and a second to the provider address) with the correct
									balance between them.</p>
								</div>
							</div>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>utxos: <a href="interfaces/utxo.html" class="tsd-signature-type">Utxo</a><span class="tsd-signature-symbol">[]</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>utxos from the multisig address i</p>
										</div>
									</div>
								</li>
								<li>
									<h5>revPubKeyAddress: <span class="tsd-signature-type">Buffer</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the revPubKey object containing the address
											and the redeem script</p>
										</div>
									</div>
								</li>
								<li>
									<h5>providerBalance: <a href="classes/btc.html" class="tsd-signature-type">Btc</a></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the amount owned by the provider</p>
										</div>
									</div>
								</li>
								<li>
									<h5>clientBalanceBeforeFee: <a href="classes/btc.html" class="tsd-signature-type">Btc</a></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the amount send to the channel</p>
										</div>
									</div>
								</li>
								<li>
									<h5>feePerByte: <a href="classes/btc.html" class="tsd-signature-type">Btc</a></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>amount of satoshis per bytes, used for the fee</p>
										</div>
									</div>
								</li>
								<li>
									<h5>providerAddress: <span class="tsd-signature-type">string</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the provider address</p>
										</div>
									</div>
								</li>
								<li>
									<h5>network: <span class="tsd-signature-type">Network</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the network used</p>
										</div>
									</div>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <a href="globals.html#channeltx" class="tsd-signature-type">ChannelTx</a></h4>
							<p>an object that contains the transaction</p>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-function">
					<a name="registerchannel" class="tsd-anchor"></a>
					<h3>register<wbr>Channel</h3>
					<ul class="tsd-signatures tsd-kind-function">
						<li class="tsd-signature tsd-kind-icon">register<wbr>Channel<span class="tsd-signature-symbol">(</span>authId<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">number</span>, authSecret<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span>, linkingCode<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">any</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">RequestPromise</span></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/common/register.ts:3</li>
								</ul>
							</aside>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>authId: <span class="tsd-signature-type">number</span></h5>
								</li>
								<li>
									<h5>authSecret: <span class="tsd-signature-type">string</span></h5>
								</li>
								<li>
									<h5>linkingCode: <span class="tsd-signature-type">any</span></h5>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <span class="tsd-signature-type">RequestPromise</span></h4>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-function">
					<a name="revhashfromsecret" class="tsd-anchor"></a>
					<h3>rev<wbr>Hash<wbr>From<wbr>Secret</h3>
					<ul class="tsd-signatures tsd-kind-function">
						<li class="tsd-signature tsd-kind-icon">rev<wbr>Hash<wbr>From<wbr>Secret<span class="tsd-signature-symbol">(</span>revSecret<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">Buffer</span></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/common/secrets/revhash.ts:9</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p>Create the revokation hash (hash160 = RIPEMD160(SHA256())) from the secret.</p>
								</div>
							</div>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>revSecret: <span class="tsd-signature-type">string</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the revokation secret</p>
										</div>
									</div>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <span class="tsd-signature-type">Buffer</span></h4>
							<p>the hash160 of the secret</p>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-function">
					<a name="revokerefundtransaction" class="tsd-anchor"></a>
					<h3>revoke<wbr>Refund<wbr>Transaction</h3>
					<ul class="tsd-signatures tsd-kind-function">
						<li class="tsd-signature tsd-kind-icon">revoke<wbr>Refund<wbr>Transaction<span class="tsd-signature-symbol">(</span>utxosAndWifs<span class="tsd-signature-symbol">: </span><a href="interfaces/utxoandwif.html" class="tsd-signature-type">UtxoAndWif</a><span class="tsd-signature-symbol">[]</span>, recipientAddress<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span>, redeemScript<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">Buffer</span>, revSecret<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span>, feePerByte<span class="tsd-signature-symbol">: </span><a href="classes/btc.html" class="tsd-signature-type">Btc</a>, network<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">Network</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><a href="interfaces/tx.html" class="tsd-signature-type">Tx</a></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/common/transaction/revokerefundtx.ts:31</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p>Create a revocation transaction that can be used to get the funds blocked
										in the revPubKey contract with the provider address and the secret. This
										transaction must be used in the case if the client broadcast an older
										refund transaction, with a lower balance for the provider. In that case,
										the provider knows the secret used in the contract and can take the money
									before the client.</p>
								</div>
							</div>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>utxosAndWifs: <a href="interfaces/utxoandwif.html" class="tsd-signature-type">UtxoAndWif</a><span class="tsd-signature-symbol">[]</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>utxos of type revPubKey contract with
												the corresponding node able to sing the output, must be the same revPubKey
											contract that the redeemScript argument</p>
										</div>
									</div>
								</li>
								<li>
									<h5>recipientAddress: <span class="tsd-signature-type">string</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>to destination address</p>
										</div>
									</div>
								</li>
								<li>
									<h5>redeemScript: <span class="tsd-signature-type">Buffer</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the redeem script of the revPubKey</p>
										</div>
									</div>
								</li>
								<li>
									<h5>revSecret: <span class="tsd-signature-type">string</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the secret to unlock the funds</p>
										</div>
									</div>
								</li>
								<li>
									<h5>feePerByte: <a href="classes/btc.html" class="tsd-signature-type">Btc</a></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the amount of satoshis per byte</p>
										</div>
									</div>
								</li>
								<li>
									<h5>network: <span class="tsd-signature-type">Network</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the used network</p>
										</div>
									</div>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <a href="interfaces/tx.html" class="tsd-signature-type">Tx</a></h4>
							<p>an object that contains the revoke refund transaction</p>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-function">
					<a name="settlementtransaction" class="tsd-anchor"></a>
					<h3>settlement<wbr>Transaction</h3>
					<ul class="tsd-signatures tsd-kind-function">
						<li class="tsd-signature tsd-kind-icon">settlement<wbr>Transaction<span class="tsd-signature-symbol">(</span>utxos<span class="tsd-signature-symbol">: </span><a href="interfaces/utxo.html" class="tsd-signature-type">Utxo</a><span class="tsd-signature-symbol">[]</span>, providerAddress<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span>, providerBalanceBeforeFee<span class="tsd-signature-symbol">: </span><a href="classes/btc.html" class="tsd-signature-type">Btc</a>, channelAddress<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">Buffer</span>, clientBalance<span class="tsd-signature-symbol">: </span><a href="classes/btc.html" class="tsd-signature-type">Btc</a>, feePerByte<span class="tsd-signature-symbol">: </span><a href="classes/btc.html" class="tsd-signature-type">Btc</a>, network<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">Network</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><a href="globals.html#channeltx" class="tsd-signature-type">ChannelTx</a></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/common/transaction/settlementtx.ts:23</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p>Create a settlement transaction that consume all the utxos given in the
										multisig address and send the settlement amount minus the fees into the
										settlement address and the remaining funds into the change address. The
										change address is the next multisig address in the channel. The transaction
										is created unsigned and is incomplete. The amount of settlement, change and
										fee must be equal to the total of satoshis present in the utxos, if not an
									exception is throw.</p>
								</div>
							</div>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>utxos: <a href="interfaces/utxo.html" class="tsd-signature-type">Utxo</a><span class="tsd-signature-symbol">[]</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>a list of utxos from the current multisig address</p>
										</div>
									</div>
								</li>
								<li>
									<h5>providerAddress: <span class="tsd-signature-type">string</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the settlement address</p>
										</div>
									</div>
								</li>
								<li>
									<h5>providerBalanceBeforeFee: <a href="classes/btc.html" class="tsd-signature-type">Btc</a></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the amount in satoshis</p>
										</div>
									</div>
								</li>
								<li>
									<h5>channelAddress: <span class="tsd-signature-type">Buffer</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the next multisig address</p>
										</div>
									</div>
								</li>
								<li>
									<h5>clientBalance: <a href="classes/btc.html" class="tsd-signature-type">Btc</a></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the reamining channel amount</p>
										</div>
									</div>
								</li>
								<li>
									<h5>feePerByte: <a href="classes/btc.html" class="tsd-signature-type">Btc</a></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the fee per byte</p>
										</div>
									</div>
								</li>
								<li>
									<h5>network: <span class="tsd-signature-type">Network</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>for create the right transaction</p>
										</div>
									</div>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <a href="globals.html#channeltx" class="tsd-signature-type">ChannelTx</a></h4>
							<p>an object that contains the transaction</p>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-function">
					<a name="spendrefundtransaction" class="tsd-anchor"></a>
					<h3>spend<wbr>Refund<wbr>Transaction</h3>
					<ul class="tsd-signatures tsd-kind-function">
						<li class="tsd-signature tsd-kind-icon">spend<wbr>Refund<wbr>Transaction<span class="tsd-signature-symbol">(</span>utxosAndWifs<span class="tsd-signature-symbol">: </span><a href="interfaces/utxoandwif.html" class="tsd-signature-type">UtxoAndWif</a><span class="tsd-signature-symbol">[]</span>, recipientAddress<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span>, redeemScript<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">Buffer</span>, blocksInFuture<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">number</span>, feePerByte<span class="tsd-signature-symbol">: </span><a href="classes/btc.html" class="tsd-signature-type">Btc</a>, network<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">Network</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><a href="interfaces/tx.html" class="tsd-signature-type">Tx</a></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/common/transaction/spendrefundtx.ts:28</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p>Create a transaction for spending the content in a revPubKey contract after
										the timelock. This transaction is used by the founder of the channel to get
									back is money from a revPubKey contract.</p>
								</div>
							</div>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>utxosAndWifs: <a href="interfaces/utxoandwif.html" class="tsd-signature-type">UtxoAndWif</a><span class="tsd-signature-symbol">[]</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>utxos of type revPubKey contract with
												the corresponding node able to sing the output, must be the same revPubKey
											contract that the redeemScript argument</p>
										</div>
									</div>
								</li>
								<li>
									<h5>recipientAddress: <span class="tsd-signature-type">string</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the destination address of the input-s</p>
										</div>
									</div>
								</li>
								<li>
									<h5>redeemScript: <span class="tsd-signature-type">Buffer</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the revPubKey contract of the input-s</p>
										</div>
									</div>
								</li>
								<li>
									<h5>blocksInFuture: <span class="tsd-signature-type">number</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the waiting lock time to spend</p>
										</div>
									</div>
								</li>
								<li>
									<h5>feePerByte: <a href="classes/btc.html" class="tsd-signature-type">Btc</a></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the amount of satoshis per byte</p>
										</div>
									</div>
								</li>
								<li>
									<h5>network: <span class="tsd-signature-type">Network</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the network used to create the transaction</p>
										</div>
									</div>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <a href="interfaces/tx.html" class="tsd-signature-type">Tx</a></h4>
							<p>an object that contains the transaction</p>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-function">
					<a name="statetransition" class="tsd-anchor"></a>
					<h3>state<wbr>Transition</h3>
					<ul class="tsd-signatures tsd-kind-function">
						<li class="tsd-signature tsd-kind-icon">state<wbr>Transition<span class="tsd-signature-symbol">(</span>clientBalance<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">object</span>, providerBalance<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">object</span>, channelTotal<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">object</span>, fee<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">object</span>, transition<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">object</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><a href="interfaces/channelstatetransition.html" class="tsd-signature-type">ChannelStateTransition</a></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/common/transaction/helper.ts:70</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p>Generate a new state object that decribe all the balances if the transaction
									is broadcast or not.</p>
								</div>
							</div>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>clientBalance: <span class="tsd-signature-type">object</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the before and after balance for the client</p>
										</div>
									</div>
									<ul class="tsd-parameters">
										<li class="tsd-parameter">
											<h5>after<wbr>Broadcast<span class="tsd-signature-symbol">: </span><a href="classes/btc.html" class="tsd-signature-type">Btc</a></h5>
										</li>
										<li class="tsd-parameter">
											<h5>no<wbr>Broadcast<span class="tsd-signature-symbol">: </span><a href="classes/btc.html" class="tsd-signature-type">Btc</a></h5>
										</li>
									</ul>
								</li>
								<li>
									<h5>providerBalance: <span class="tsd-signature-type">object</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the before and after balance for the provider</p>
										</div>
									</div>
									<ul class="tsd-parameters">
										<li class="tsd-parameter">
											<h5>after<wbr>Broadcast<span class="tsd-signature-symbol">: </span><a href="classes/btc.html" class="tsd-signature-type">Btc</a></h5>
										</li>
										<li class="tsd-parameter">
											<h5>no<wbr>Broadcast<span class="tsd-signature-symbol">: </span><a href="classes/btc.html" class="tsd-signature-type">Btc</a></h5>
										</li>
									</ul>
								</li>
								<li>
									<h5>channelTotal: <span class="tsd-signature-type">object</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the remaining amount in the channel before and
											after</p>
										</div>
									</div>
									<ul class="tsd-parameters">
										<li class="tsd-parameter">
											<h5>after<wbr>Broadcast<span class="tsd-signature-symbol">: </span><a href="classes/btc.html" class="tsd-signature-type">Btc</a></h5>
										</li>
										<li class="tsd-parameter">
											<h5>no<wbr>Broadcast<span class="tsd-signature-symbol">: </span><a href="classes/btc.html" class="tsd-signature-type">Btc</a></h5>
										</li>
									</ul>
								</li>
								<li>
									<h5>fee: <span class="tsd-signature-type">object</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the amount of fee, the same in both case</p>
										</div>
									</div>
									<ul class="tsd-parameters">
										<li class="tsd-parameter">
											<h5>after<wbr>Broadcast<span class="tsd-signature-symbol">: </span><a href="classes/btc.html" class="tsd-signature-type">Btc</a></h5>
										</li>
										<li class="tsd-parameter">
											<h5>no<wbr>Broadcast<span class="tsd-signature-symbol">: </span><a href="classes/btc.html" class="tsd-signature-type">Btc</a></h5>
										</li>
									</ul>
								</li>
								<li>
									<h5>transition: <span class="tsd-signature-type">object</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the transition for the state</p>
										</div>
									</div>
									<ul class="tsd-parameters">
										<li class="tsd-parameter">
											<h5>after<wbr>Broadcast<span class="tsd-signature-symbol">: </span><a href="globals.html#transition" class="tsd-signature-type">Transition</a></h5>
										</li>
										<li class="tsd-parameter">
											<h5>no<wbr>Broadcast<span class="tsd-signature-symbol">: </span><a href="globals.html#transition" class="tsd-signature-type">Transition</a></h5>
										</li>
									</ul>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <a href="interfaces/channelstatetransition.html" class="tsd-signature-type">ChannelStateTransition</a></h4>
							<p>the state transition object containing the
							new states</p>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-function">
					<a name="validbalancesorthrow" class="tsd-anchor"></a>
					<h3>valid<wbr>Balances<wbr>OrThrow</h3>
					<ul class="tsd-signatures tsd-kind-function">
						<li class="tsd-signature tsd-kind-icon">valid<wbr>Balances<wbr>OrThrow<span class="tsd-signature-symbol">(</span>total<span class="tsd-signature-symbol">: </span><a href="classes/btc.html" class="tsd-signature-type">Btc</a>, <span class="tsd-signature-symbol">...</span>balances<span class="tsd-signature-symbol">: </span><a href="classes/btc.html" class="tsd-signature-type">Btc</a><span class="tsd-signature-symbol">[]</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">boolean</span></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/common/transaction/helper.ts:43</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p>Validate the balance and throw an error if the channel balance is not
									correct. Take a total value in Btc and all the different balances.</p>
								</div>
							</div>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>total: <a href="classes/btc.html" class="tsd-signature-type">Btc</a></h5>
								</li>
								<li>
									<h5><span class="tsd-flag ts-flagRest">Rest</span> <span class="tsd-signature-symbol">...</span>balances: <a href="classes/btc.html" class="tsd-signature-type">Btc</a><span class="tsd-signature-symbol">[]</span></h5>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <span class="tsd-signature-type">boolean</span></h4>
							<p>if the balance is valid, throw an error if not equals</p>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-function">
					<a name="verifysignature" class="tsd-anchor"></a>
					<h3>verify<wbr>Signature</h3>
					<ul class="tsd-signatures tsd-kind-function">
						<li class="tsd-signature tsd-kind-icon">verify<wbr>Signature<span class="tsd-signature-symbol">(</span>builder<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">TransactionBuilder</span>, clientNode<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">HDNode</span>, providerNode<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">HDNode</span>, pubkeys<span class="tsd-signature-symbol">: </span><a href="interfaces/clientproviderpubkeys.html" class="tsd-signature-type">ClientProviderPubkeys</a>, signatureToBeVerified<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">"provider"</span><span class="tsd-signature-symbol"> | </span><span class="tsd-signature-type">"client"</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">object</span></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/common/signature/verifysig.ts:10</li>
								</ul>
							</aside>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>builder: <span class="tsd-signature-type">TransactionBuilder</span></h5>
								</li>
								<li>
									<h5>clientNode: <span class="tsd-signature-type">HDNode</span></h5>
								</li>
								<li>
									<h5>providerNode: <span class="tsd-signature-type">HDNode</span></h5>
								</li>
								<li>
									<h5>pubkeys: <a href="interfaces/clientproviderpubkeys.html" class="tsd-signature-type">ClientProviderPubkeys</a></h5>
								</li>
								<li>
									<h5>signatureToBeVerified: <span class="tsd-signature-type">"provider"</span><span class="tsd-signature-symbol"> | </span><span class="tsd-signature-type">"client"</span></h5>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <span class="tsd-signature-type">object</span></h4>
							<ul class="tsd-parameters">
								<li class="tsd-parameter">
									<h5>verified<wbr>Script<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">any</span></h5>
								</li>
								<li class="tsd-parameter">
									<h5>verified<wbr>Signature<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">any</span></h5>
								</li>
							</ul>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-function">
					<a name="withdrawtransaction" class="tsd-anchor"></a>
					<h3>withdraw<wbr>Transaction</h3>
					<ul class="tsd-signatures tsd-kind-function">
						<li class="tsd-signature tsd-kind-icon">withdraw<wbr>Transaction<span class="tsd-signature-symbol">(</span>utxos<span class="tsd-signature-symbol">: </span><a href="interfaces/utxo.html" class="tsd-signature-type">Utxo</a><span class="tsd-signature-symbol">[]</span>, providerAddress<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span>, providerBalance<span class="tsd-signature-symbol">: </span><a href="classes/btc.html" class="tsd-signature-type">Btc</a>, withdrawAddress<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span>, withdrawAmount<span class="tsd-signature-symbol">: </span><a href="classes/btc.html" class="tsd-signature-type">Btc</a>, changeAddress<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span>, changeAmount<span class="tsd-signature-symbol">: </span><a href="classes/btc.html" class="tsd-signature-type">Btc</a>, feePerByte<span class="tsd-signature-symbol">: </span><a href="classes/btc.html" class="tsd-signature-type">Btc</a>, network<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">Network</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><a href="globals.html#channeltx" class="tsd-signature-type">ChannelTx</a></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/common/transaction/withdrawtx.ts:22</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p>Create a transaction with three output, one to the provider, one to the
										client and one to an arbitrary address. This transaction is a cooperative
										transaction, it means that both part have to be cooperative to create this
									transaction on demand.</p>
								</div>
							</div>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>utxos: <a href="interfaces/utxo.html" class="tsd-signature-type">Utxo</a><span class="tsd-signature-symbol">[]</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>an array of utxos used to create the transaction</p>
										</div>
									</div>
								</li>
								<li>
									<h5>providerAddress: <span class="tsd-signature-type">string</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the settlement address</p>
										</div>
									</div>
								</li>
								<li>
									<h5>providerBalance: <a href="classes/btc.html" class="tsd-signature-type">Btc</a></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the settlement amount</p>
										</div>
									</div>
								</li>
								<li>
									<h5>withdrawAddress: <span class="tsd-signature-type">string</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the withdraw address</p>
										</div>
									</div>
								</li>
								<li>
									<h5>withdrawAmount: <a href="classes/btc.html" class="tsd-signature-type">Btc</a></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the withdraw amount</p>
										</div>
									</div>
								</li>
								<li>
									<h5>changeAddress: <span class="tsd-signature-type">string</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the next channel address</p>
										</div>
									</div>
								</li>
								<li>
									<h5>changeAmount: <a href="classes/btc.html" class="tsd-signature-type">Btc</a></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the amount due to the client on the next address</p>
										</div>
									</div>
								</li>
								<li>
									<h5>feePerByte: <a href="classes/btc.html" class="tsd-signature-type">Btc</a></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the amount of satoshis per byte of tx</p>
										</div>
									</div>
								</li>
								<li>
									<h5>network: <span class="tsd-signature-type">Network</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the network used to create the transaction</p>
										</div>
									</div>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <a href="globals.html#channeltx" class="tsd-signature-type">ChannelTx</a></h4>
							<p>an object that contains the transaction</p>
						</li>
					</ul>
				</section>
			</section>
			<section class="tsd-panel-group tsd-member-group tsd-is-not-exported">
				<h2>Object literals</h2>
				<section class="tsd-panel tsd-member tsd-kind-object-literal tsd-is-not-exported">
					<a name="common" class="tsd-anchor"></a>
					<h3>common</h3>
					<div class="tsd-signature tsd-kind-icon">common<span class="tsd-signature-symbol">:</span> <span class="tsd-signature-type">object</span></div>
					<aside class="tsd-sources">
						<ul>
							<li>Defined in lib/common/api/btcapirpc.ts:5</li>
						</ul>
					</aside>
					<section class="tsd-panel tsd-member tsd-kind-variable tsd-parent-kind-object-literal tsd-is-not-exported">
						<a name="common.host" class="tsd-anchor"></a>
						<h3>host</h3>
						<div class="tsd-signature tsd-kind-icon">host<span class="tsd-signature-symbol">:</span> <span class="tsd-signature-type">any</span><span class="tsd-signature-symbol"> =&nbsp;host</span></div>
						<aside class="tsd-sources">
							<ul>
								<li>Defined in lib/common/api/btcapirpc.ts:7</li>
							</ul>
						</aside>
					</section>
					<section class="tsd-panel tsd-member tsd-kind-variable tsd-parent-kind-object-literal tsd-is-not-exported">
						<a name="common.password" class="tsd-anchor"></a>
						<h3>password</h3>
						<div class="tsd-signature tsd-kind-icon">password<span class="tsd-signature-symbol">:</span> <span class="tsd-signature-type">string</span><span class="tsd-signature-symbol"> =&nbsp;&quot;test&quot;</span></div>
						<aside class="tsd-sources">
							<ul>
								<li>Defined in lib/common/api/btcapirpc.ts:9</li>
							</ul>
						</aside>
					</section>
					<section class="tsd-panel tsd-member tsd-kind-variable tsd-parent-kind-object-literal tsd-is-not-exported">
						<a name="common.username" class="tsd-anchor"></a>
						<h3>username</h3>
						<div class="tsd-signature tsd-kind-icon">username<span class="tsd-signature-symbol">:</span> <span class="tsd-signature-type">string</span><span class="tsd-signature-symbol"> =&nbsp;&quot;test&quot;</span></div>
						<aside class="tsd-sources">
							<ul>
								<li>Defined in lib/common/api/btcapirpc.ts:8</li>
							</ul>
						</aside>
					</section>
				</section>
			</section>
		</div>
		<div class="col-4 col-menu menu-sticky-wrap menu-highlight">
			<nav class="tsd-navigation primary">
				<ul>
					<li class="globals current ">
						<a href="globals.html"><em>Globals</em></a>
					</li>
					<li class=" tsd-kind-module">
						<a href="modules/derivation.html">derivation</a>
					</li>
				</ul>
			</nav>
			<nav class="tsd-navigation secondary menu-sticky">
				<ul class="before-current">
					<li class=" tsd-kind-class">
						<a href="classes/btc.html" class="tsd-kind-icon">Btc</a>
					</li>
					<li class=" tsd-kind-class">
						<a href="classes/client.html" class="tsd-kind-icon">Client</a>
					</li>
					<li class=" tsd-kind-class">
						<a href="classes/clientkernel.html" class="tsd-kind-icon">Client<wbr>Kernel</a>
					</li>
					<li class=" tsd-kind-class">
						<a href="classes/kernel.html" class="tsd-kind-icon">Kernel</a>
					</li>
					<li class=" tsd-kind-class">
						<a href="classes/multisig.html" class="tsd-kind-icon">Multisig</a>
					</li>
					<li class=" tsd-kind-class tsd-is-not-exported">
						<a href="classes/multisigclient.html" class="tsd-kind-icon">Multisig<wbr>Client</a>
					</li>
					<li class=" tsd-kind-class tsd-is-not-exported">
						<a href="classes/multisigprovider.html" class="tsd-kind-icon">Multisig<wbr>Provider</a>
					</li>
					<li class=" tsd-kind-class">
						<a href="classes/protocol.html" class="tsd-kind-icon">Protocol</a>
					</li>
					<li class=" tsd-kind-class">
						<a href="classes/revpubkey.html" class="tsd-kind-icon">Rev<wbr>Pubkey</a>
					</li>
					<li class=" tsd-kind-class tsd-is-not-exported">
						<a href="classes/revpubkeyclient.html" class="tsd-kind-icon">Rev<wbr>Pubkey<wbr>Client</a>
					</li>
					<li class=" tsd-kind-class tsd-is-not-exported">
						<a href="classes/revpubkeyprovider.html" class="tsd-kind-icon">Rev<wbr>Pubkey<wbr>Provider</a>
					</li>
					<li class=" tsd-kind-class">
						<a href="classes/server.html" class="tsd-kind-icon">Server</a>
					</li>
					<li class=" tsd-kind-class">
						<a href="classes/serverkernel.html" class="tsd-kind-icon">Server<wbr>Kernel</a>
					</li>
					<li class=" tsd-kind-class">
						<a href="classes/testkernel.html" class="tsd-kind-icon">Test<wbr>Kernel</a>
					</li>
					<li class=" tsd-kind-interface">
						<a href="interfaces/channeladdress.html" class="tsd-kind-icon">Channel<wbr>Address</a>
					</li>
					<li class=" tsd-kind-interface">
						<a href="interfaces/channelstatetransition.html" class="tsd-kind-icon">Channel<wbr>State<wbr>Transition</a>
					</li>
					<li class=" tsd-kind-interface">
						<a href="interfaces/clientproviderpubkeys.html" class="tsd-kind-icon">Client<wbr>Provider<wbr>Pubkeys</a>
					</li>
					<li class=" tsd-kind-interface">
						<a href="interfaces/requestapi.html" class="tsd-kind-icon">Request<wbr>Api</a>
					</li>
					<li class=" tsd-kind-interface">
						<a href="interfaces/revpubkey.html" class="tsd-kind-icon">Rev<wbr>Pub<wbr>Key</a>
					</li>
					<li class=" tsd-kind-interface">
						<a href="interfaces/tx.html" class="tsd-kind-icon">Tx</a>
					</li>
					<li class=" tsd-kind-interface">
						<a href="interfaces/utxo.html" class="tsd-kind-icon">Utxo</a>
					</li>
					<li class=" tsd-kind-interface">
						<a href="interfaces/utxoandwif.html" class="tsd-kind-icon">Utxo<wbr>And<wbr>Wif</a>
					</li>
					<li class=" tsd-kind-type-alias">
						<a href="globals.html#apiname" class="tsd-kind-icon">Api<wbr>Name</a>
					</li>
					<li class=" tsd-kind-type-alias">
						<a href="globals.html#channeltx" class="tsd-kind-icon">Channel<wbr>Tx</a>
					</li>
					<li class=" tsd-kind-type-alias">
						<a href="globals.html#networkname" class="tsd-kind-icon">Network<wbr>Name</a>
					</li>
					<li class=" tsd-kind-type-alias">
						<a href="globals.html#transition" class="tsd-kind-icon">Transition</a>
					</li>
					<li class=" tsd-kind-variable tsd-is-not-exported">
						<a href="globals.html#biginteger" class="tsd-kind-icon">Big<wbr>Integer</a>
					</li>
					<li class=" tsd-kind-variable tsd-is-not-exported">
						<a href="globals.html#op_checksequenceverify" class="tsd-kind-icon">OP_<wbr>CHECKSEQUENCEVERIFY</a>
					</li>
					<li class=" tsd-kind-variable">
						<a href="globals.html#apiname" class="tsd-kind-icon">api<wbr>Name</a>
					</li>
					<li class=" tsd-kind-variable tsd-is-not-exported">
						<a href="globals.html#host" class="tsd-kind-icon">host</a>
					</li>
					<li class=" tsd-kind-variable">
						<a href="globals.html#networkname" class="tsd-kind-icon">network<wbr>Name</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#btcapi" class="tsd-kind-icon">BTCApi</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#btcapiinsight" class="tsd-kind-icon">BTCApi<wbr>Insight</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#btcapirpc" class="tsd-kind-icon">BTCApiRPC</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#csvrevpubkeyoutput" class="tsd-kind-icon">csv<wbr>Rev<wbr>Pub<wbr>Key<wbr>Output</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#derivechanneladdress" class="tsd-kind-icon">derive<wbr>Channel<wbr>Address</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#deriverevpubkey" class="tsd-kind-icon">derive<wbr>Rev<wbr>Pubkey</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#deriverevsecret" class="tsd-kind-icon">derive<wbr>Rev<wbr>Secret</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#deriveusernode" class="tsd-kind-icon">derive<wbr>User<wbr>Node</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#fundingtransaction" class="tsd-kind-icon">funding<wbr>Transaction</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#generateseed" class="tsd-kind-icon">generate<wbr>Seed</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#getfeeperbyte" class="tsd-kind-icon">get<wbr>Fee<wbr>Per<wbr>Byte</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#getoutputs" class="tsd-kind-icon">get<wbr>Outputs</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#getpubkeys" class="tsd-kind-icon">get<wbr>Pubkeys</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#refundtransaction" class="tsd-kind-icon">refund<wbr>Transaction</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#registerchannel" class="tsd-kind-icon">register<wbr>Channel</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#revhashfromsecret" class="tsd-kind-icon">rev<wbr>Hash<wbr>From<wbr>Secret</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#revokerefundtransaction" class="tsd-kind-icon">revoke<wbr>Refund<wbr>Transaction</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#settlementtransaction" class="tsd-kind-icon">settlement<wbr>Transaction</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#spendrefundtransaction" class="tsd-kind-icon">spend<wbr>Refund<wbr>Transaction</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#statetransition" class="tsd-kind-icon">state<wbr>Transition</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#validbalancesorthrow" class="tsd-kind-icon">valid<wbr>Balances<wbr>OrThrow</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#verifysignature" class="tsd-kind-icon">verify<wbr>Signature</a>
					</li>
					<li class=" tsd-kind-function">
						<a href="globals.html#withdrawtransaction" class="tsd-kind-icon">withdraw<wbr>Transaction</a>
					</li>
					<li class=" tsd-kind-object-literal tsd-is-not-exported">
						<a href="globals.html#common" class="tsd-kind-icon">common</a>
					</li>
				</ul>
			</nav>
		</div>
	</div>
</div>
<footer class="with-border-bottom">
	<div class="container">
		<h2>Legend</h2>
		<div class="tsd-legend-group">
			<ul class="tsd-legend">
				<li class="tsd-kind-module"><span class="tsd-kind-icon">Module</span></li>
				<li class="tsd-kind-object-literal"><span class="tsd-kind-icon">Object literal</span></li>
				<li class="tsd-kind-variable"><span class="tsd-kind-icon">Variable</span></li>
				<li class="tsd-kind-function"><span class="tsd-kind-icon">Function</span></li>
				<li class="tsd-kind-function tsd-has-type-parameter"><span class="tsd-kind-icon">Function with type parameter</span></li>
				<li class="tsd-kind-index-signature"><span class="tsd-kind-icon">Index signature</span></li>
				<li class="tsd-kind-type-alias"><span class="tsd-kind-icon">Type alias</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-enum"><span class="tsd-kind-icon">Enumeration</span></li>
				<li class="tsd-kind-enum-member"><span class="tsd-kind-icon">Enumeration member</span></li>
				<li class="tsd-kind-property tsd-parent-kind-enum"><span class="tsd-kind-icon">Property</span></li>
				<li class="tsd-kind-method tsd-parent-kind-enum"><span class="tsd-kind-icon">Method</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-interface"><span class="tsd-kind-icon">Interface</span></li>
				<li class="tsd-kind-interface tsd-has-type-parameter"><span class="tsd-kind-icon">Interface with type parameter</span></li>
				<li class="tsd-kind-constructor tsd-parent-kind-interface"><span class="tsd-kind-icon">Constructor</span></li>
				<li class="tsd-kind-property tsd-parent-kind-interface"><span class="tsd-kind-icon">Property</span></li>
				<li class="tsd-kind-method tsd-parent-kind-interface"><span class="tsd-kind-icon">Method</span></li>
				<li class="tsd-kind-index-signature tsd-parent-kind-interface"><span class="tsd-kind-icon">Index signature</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-class"><span class="tsd-kind-icon">Class</span></li>
				<li class="tsd-kind-class tsd-has-type-parameter"><span class="tsd-kind-icon">Class with type parameter</span></li>
				<li class="tsd-kind-constructor tsd-parent-kind-class"><span class="tsd-kind-icon">Constructor</span></li>
				<li class="tsd-kind-property tsd-parent-kind-class"><span class="tsd-kind-icon">Property</span></li>
				<li class="tsd-kind-method tsd-parent-kind-class"><span class="tsd-kind-icon">Method</span></li>
				<li class="tsd-kind-accessor tsd-parent-kind-class"><span class="tsd-kind-icon">Accessor</span></li>
				<li class="tsd-kind-index-signature tsd-parent-kind-class"><span class="tsd-kind-icon">Index signature</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-constructor tsd-parent-kind-class tsd-is-inherited"><span class="tsd-kind-icon">Inherited constructor</span></li>
				<li class="tsd-kind-property tsd-parent-kind-class tsd-is-inherited"><span class="tsd-kind-icon">Inherited property</span></li>
				<li class="tsd-kind-method tsd-parent-kind-class tsd-is-inherited"><span class="tsd-kind-icon">Inherited method</span></li>
				<li class="tsd-kind-accessor tsd-parent-kind-class tsd-is-inherited"><span class="tsd-kind-icon">Inherited accessor</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-property tsd-parent-kind-class tsd-is-protected"><span class="tsd-kind-icon">Protected property</span></li>
				<li class="tsd-kind-method tsd-parent-kind-class tsd-is-protected"><span class="tsd-kind-icon">Protected method</span></li>
				<li class="tsd-kind-accessor tsd-parent-kind-class tsd-is-protected"><span class="tsd-kind-icon">Protected accessor</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-property tsd-parent-kind-class tsd-is-private"><span class="tsd-kind-icon">Private property</span></li>
				<li class="tsd-kind-method tsd-parent-kind-class tsd-is-private"><span class="tsd-kind-icon">Private method</span></li>
				<li class="tsd-kind-accessor tsd-parent-kind-class tsd-is-private"><span class="tsd-kind-icon">Private accessor</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-property tsd-parent-kind-class tsd-is-static"><span class="tsd-kind-icon">Static property</span></li>
				<li class="tsd-kind-call-signature tsd-parent-kind-class tsd-is-static"><span class="tsd-kind-icon">Static method</span></li>
			</ul>
		</div>
	</div>
</footer>
<div class="container tsd-generator">
	<p>Generated using <a href="http://typedoc.org/" target="_blank">TypeDoc</a></p>
</div>
<div class="overlay"></div>
<script src="assets/js/main.js"></script>
<script>if (location.protocol == 'file:') document.write('<script src="assets/js/search.js"><' + '/script>');</script>
</body>
</html>